#pragma once
#include <fstream>
#include "photoinfo.h"
#include "file_io_lib.h"

class DS_slice
{
public:
	DS_slice(unsigned short int nwY, unsigned short int nwX);
	~DS_slice(void);

	void clear();
	bool write_to_RAW(char* out_file);
	bool read_from_file(Photoinfo* info, unsigned short int z_indx);

	//public variables
	unsigned short int wY;
	unsigned short int wX;

	unsigned char ** data;
	unsigned char * memory;
};

class DS_slice_si
{//short ints
public:
	DS_slice_si(unsigned short int nwY, unsigned short int nwX);
	~DS_slice_si(void);

	//void clear();
	//bool write_to_RAW(char* out_file);
	//bool read_from_file(Photoinfo* info, unsigned short int z_indx);

	//public variables
	unsigned short int wY;
	unsigned short int wX;

	short int ** data;
	short int * memory;
};


class DS_slice_f
{//floats
public:
	DS_slice_f(unsigned short int nwY, unsigned short int nwX);
	~DS_slice_f(void);

	//void clear();
	//bool write_to_RAW(char* out_file);
	//bool read_from_file(Photoinfo* info, unsigned short int z_indx);

	//public variables
	unsigned short int wY;
	unsigned short int wX;

	float ** data;
	float * memory;
};